MyGuildNotes = LibStub("AceAddon-3.0"):NewAddon("MyGuildNotes", "AceConsole-3.0", "AceTimer-3.0")

local GN = MyGuildNotes
local version = "v2.1b"
local ModName = "My Guild Notes "..version

local BLACK	= "|cFF000000"
local WHITE	= "|cFFFFFFFF"
local RED	= "|cFFFF0000"
local ORANGE	= "|cFFFF7F00"
local YELLOW	= "|cFFFFFF00"
local GREEN	= "|cFF00FF00"
local BLUE	= "|cFF1533AD"
local TEAL	= "|cFF00FF9A"
local GOLD	= "|cFFFFD700"

local MyGNAliasDB = {}
local MyGNAliasDBList = {}
MyGuildNotesVars = {}
local MyGuildNotesJoin = {} 
MyGuildNotesJoins = {}
local MyGuildNotesQuit = {}
MyGuildNotesQuits = {}
local MyGuildNotesRemove = {}
MyGuildNotesRemoves = {}
local MyGuildNotesOnline = {}

local MyGuildNotesDB = {} -- Temporary list just for displaying guild membership
MyGuildNotesDataBase = {} -- Database for all Guild Character Information Past and Present!
local MyGNIndex = {}  -- Generates a reference list for finding toons in the DataBase by name/number
local MyGuildNotesText = {}

local MyGuildNotesDataBaseLoad = 0 -- Not Loaded
MyGNDisplayTable = {}

local MYGNFOUND = 0
local MYGNINDEX
local MyGNDelta = 0
local MyGNDate = {}

local MyGNPublicNote
local MyGNOfficerNote
local JUNK, JUNK1, JUNK2, JUNK3
local MYGNSKIP = 0
local MyEventLogReadyDelay = 0
local MyGNVariablesLoaded = 0
local total = 0
local MyPageShown = 0
local MyGuildNotesDefaultData = 0
local MyGuildNotesAreOpen = 0
local MyGNInfoFrameOpen = 0
local MyGNEdit = 0

local frame = CreateFrame("Frame");

local function WatchDog(self, event, message, sender, arg1, arg2, ...)

if CanEditPublicNote() == 1 and CanEditOfficerNote() == 1 then

	if event == "PLAYER_ENTERING_WORLD" then

		GuildRoster() -- Forces a Roster Update when entering/exiting instances, etc.
		if MyGuildNotesDefaultData == 0 then
		   for n = 1, 20 do
		   if MyGuildNotesJoins[n] == nil then MyGuildNotesJoins[n] = "" end
		   if MyGuildNotesQuits[n] == nil then MyGuildNotesQuits[n] = "" end
		   if MyGuildNotesRemoves[n] == nil then MyGuildNotesRemoves[n] = "" end
		   end

		MyGuildNotesDefaultData = 1
		end
		if MyGuildNotesVars.ICON == nil then MyGuildNotesVars.ICON = 0 end
		if MyGuildNotesVars.ICONBa == nil then
		MyGuildNotesVars.ICONBa = "CENTER"
		MyGuildNotesVars.ICONBb = "Minimap"
		MyGuildNotesVars.ICONBc = "CENTER"
		MyGuildNotesVars.ICONBx = 26
		MyGuildNotesVars.ICONBy = -165
		end
		if MyGuildNotesVars.GNPUBOPTION == nil then MyGuildNotesVars.GNPUBOPTION = 4 end
		if MyGuildNotesVars.GNOFFOPTION == nil then MyGuildNotesVars.GNOFFOPTION = 4 end
		if MyGuildNotesVars.MyGNJoinMax == nil then MyGuildNotesVars.MyGNJoinMax = 60 end
		if MyGuildNotesVars.MyGNQuitMax == nil then MyGuildNotesVars.MyGNQuitMax = 60 end
		if MyGuildNotesVars.MyGNKickMax == nil then MyGuildNotesVars.MyGNKickMax = 60 end
		if MyGuildNotesVars.DELTA == nil then MyGuildNotesVars.DELTA = 10 end

		MyGNVariablesLoaded = 1
		return;

	elseif event == "GUILD_ROSTER_UPDATE" then

		MyGuildNotesVars.MyNumMembers = GetNumGuildMembers()
		QueryGuildEventLog()
		MyGuildNotesVars.GuildName = GetGuildInfo("player")
		if MyGuildNotesVars.GuildDate == nil then GuildInfo() end -- This should only happen the first time the mod is run.		 
		if MyGuildNotesFrame == nil and MyGNVariablesLoaded == 1 then GN:LoadGUI() end
		if MyGuildNotesFrame ~= nil and MyGuildNotesVars.GuildName ~= nil then MyGuildNotesTitle:SetText(MyGuildNotesVars.GuildName) end
		if MyGuildNotesFrame ~= nil then MyGuildNotesICONDisplay:SetText(MyGuildNotesVars.MyNumMembers) end
		if MyGuildNotesICON ~= nil then	
		MyGuildNotesICON:ClearAllPoints()
		MyGuildNotesICON:SetPoint(MyGuildNotesVars.ICONBa, MyGuildNotesVars.ICONBb, MyGuildNotesVars.ICONBc, MyGuildNotesVars.ICONBx, MyGuildNotesVars.ICONBy)
		    if MyGuildNotesVars.ICON == 0 then
		    MyGuildNotesICON:Show()
		    MyGuildNotesICONB:Show()
		    else
		    MyGuildNotesICONB:Hide()
		    end
		end

		MyEventLogReadyDelay = MyEventLogReadyDelay + 1
		if MyEventLogReadyDelay >= 3 then MyEventLogReady = 1 end

------------------------- MAIN DATA BASE ---------------------------
if MyGuildNotesVars.MyNumMembers ~= 0 then
wipe(MyGuildNotesOnline)
wipe(MyGNAliasDB)
wipe(MyGNAliasDBList)
local MyGNOnlineList = 1

   for i = 1, MyGuildNotesVars.MyNumMembers do
	name, rankName, rankIndex, level, class, zone, note, onote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR = GetGuildRosterInfo(i)
	if zone == nil then zone = "Unknown Location" end
	if isMobile == true then online = 1 zone = "Remote Chat" end
	if online == 1 then MyGuildNotesOnline[MyGNOnlineList] = level.." "..name.." "..YELLOW.."("..zone..")" end
	if MyGuildNotesOnline[1] == nil then MyGuildNotesOnline[6] = "UNABLE TO SHOW ONLINE CHARACTERS" MyGuildNotesOnline[7] = "  WHILE THE SHOW OFFLINE MEMBERS" MyGuildNotesOnline[8] = "TABBED IS CHECKED ON THE GUILD PAGE" end
	MyGNOnlineList = MyGNOnlineList + 1

	for k = 1, #MyGuildNotesDataBase, 25 do

		if name == MyGuildNotesDataBase[k] and class == MyGuildNotesDataBase[k+2] then
		MYGNSKIP = 1 -- This Person is in the database already, don't add them.

		---- Check to see if certain information has changed for that character.
		   if level ~= MyGuildNotesDataBase[k+1] then
			MyGNEdit = 0 
			MyGuildNotesDataBase[k+1] = level
		   end

		   if note ~= MyGuildNotesDataBase[k+3] then
			MyGNEdit = 0 
			if MyGuildNotesDataBase[k+3] == "" then MyGuildNotesDataBase[k+3] = "BLANK" end -- Just temporarily setting a value so you know it was left blank.
			print (ORANGE.."MyGuildNotes: "..WHITE.."Old Note for "..ORANGE..name..GREEN.." was: "..WHITE..MyGuildNotesDataBase[k+3])
			MyGuildNotesDataBase[k+3] = note
 			print (ORANGE.."MyGuildNotes: "..WHITE.."New Note for "..ORANGE..name..GREEN.." is: "..WHITE..note)
		   end

		   if onote ~= MyGuildNotesDataBase[k+4] then
			MyGNEdit = 0 
			if MyGuildNotesDataBase[k+4] == "" then MyGuildNotesDataBase[k+4] = "BLANK" end -- Just temporarily setting a value so you know it was left blank.			
			print (ORANGE.."MyGuildNotes: "..WHITE.."Old Officer Note for "..ORANGE..name..GREEN.." was: "..WHITE..MyGuildNotesDataBase[k+5])
			MyGuildNotesDataBase[k+4] = onote
 			print (ORANGE.."MyGuildNotes: "..WHITE.."New Officer Note for "..ORANGE..name..GREEN.." is: "..WHITE..onote)
		   end

		   if rankIndex ~= MyGuildNotesDataBase[k+22] then
			MyGuildNotesDataBase[k+22] = rankIndex
			MyGuildNotesDataBase[k+23] = rankName
		   end

		   if achievementPoints ~= MyGuildNotesDataBase[k+20] then MyGuildNotesDataBase[k+20] = achievementPoints end
		   if achievementRank ~= MyGuildNotesDataBase[k+21] then MyGuildNotesDataBase[k+21] = achievementRank end

		end


	end
	
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = name end
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = level end 		-- +1
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = class end			-- +2
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = note end			-- +3	-- Current Public Note
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = onote end			-- +4 	-- Current Officer's Note
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +5 	-- Main -- Used to track character's Alts
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +6 	
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +7   
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end 			-- +8	
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +9	
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +10	
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +11
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +12
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +13
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +14  
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +15  
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +16  -- Private Note
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +17  -- Date Joined -- User/Mod Input
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "" end			-- +18  -- Date Left -- Mod Input Only
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = "Member" end		-- +19	-- Status with guild -- Member/Left/Kicked
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = achievementPoints end	-- +20
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = achievementRank end	-- +21
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = rankIndex end		-- +22
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = rankName end		-- +23 
	if MYGNSKIP == 0 then MyGuildNotesDataBase[#MyGuildNotesDataBase+1] = MyGuildNotesVars.GuildName end	-- +24  --Guild Affiliation
	MYGNSKIP = 0

   end
if MyGuildNotesDataBaseLoad == 0 and MyGuildNotesVars.ICON == 1 then print(WHITE.."MyGuildNotes: "..GREEN.."Guild Membership is: "..WHITE, MyGuildNotesVars.MyNumMembers, GREEN.." characters!") end
if MyGuildNotesDataBaseLoad == 0 then print(WHITE.."MyGuildNotes: "..GREEN.."History for "..WHITE, #MyGuildNotesDataBase/25, GREEN.." characters stored!") end

MyGuildNotesDataBaseLoad = 1
----------------------- END MAIN DATA BASE ---------------------------
return;
end

	elseif event == "GUILD_EVENT_LOG_UPDATE" then
wipe(MyGuildNotesDB)
wipe(MyGuildNotesJoin)
wipe(MyGuildNotesQuit)
wipe(MyGuildNotesRemove)
		local m = 0
		local q = 0
		local r = 0
		local b = 0
		local MyNumEvents = GetNumGuildEvents()
		MyGuildNotesVars.MyNumMembers = GetNumGuildMembers()

			for i = 1, MyNumEvents do
			local type, player1, player2, rank, year, month, day, hour = GetGuildEventInfo(i)
		
			if player1 ~= nil then
			if player2 == nil then player2 = "UNKNOWN" end
			level = "__"

			    if type == "remove" then
				for j = 1, #MyGuildNotesDataBase, 25 do
				if MyGuildNotesDataBase[j] == player2 then
					level = MyGuildNotesDataBase[j+1]
					JUNK = year*315536000+month*2592000+day*86400+hour*3600
					MyDateKick = date("%m/%d/%Y", time()-JUNK)
					MyGuildNotesDataBase[j+18] = MyDateKick
					MyGuildNotesDataBase[j+19] = "Kicked"
					end
				if string.len(level) ==1 then level = "0"..level end
				end
				JUNK = year*315536000+month*2592000+day*86400
				day = JUNK/86400
				if day <= MyGuildNotesVars.MyGNKickMax then
					r=r+1
				  	if day ~= 0 then MyGuildNotesRemove[r] = level.." "..player2.." "..day.." days ago by "..player1 end
					if day >= 60 then month = math.floor(day/30) MyGuildNotesRemove[r] = level.." "..player2.." "..month.." months ago by "..player1 end
					if day == 1 then MyGuildNotesRemove[r] = level.." "..player2.." yesterday by "..player1 end
					if day == 0 then MyGuildNotesRemove[r] = level.." "..player2.." today by "..player1 end
				end
			    end

			    if type == "quit" then

				if UnitIsInMyGuild(player1) ~= 1 then -- ignore if they rejoined				
						JUNK = year*315536000+month*2592000+day*86400
						day = JUNK/86400
						if string.len(level) == 1 then level = "0"..level end
						if day <= MyGuildNotesVars.MyGNQuitMax then q=q+1 MyGuildNotesQuit[q] = day.." "..player1.." "..level end

						for j = 1, #MyGuildNotesDataBase, 25 do -- This also puts the Quit Date in the File
						if MyGuildNotesDataBase[j] == player1 then
							level = MyGuildNotesDataBase[j+1]
							JUNK = year*315536000+month*2592000+day*86400+hour*3600
							MyDateQuit = date("%m/%d/%Y", time()-JUNK)
							MyGuildNotesDataBase[j+18] = MyDateQuit
							MyGuildNotesDataBase[j+19] = "Quit"
							if string.len(level) == 1 then level = "0"..level end
							MyGuildNotesQuit[q] = day.." "..player1.." "..level
						end
						end
			        end
			    end


			    if type == "join" then

				for j = 1, MyGuildNotesVars.MyNumMembers do
				    name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR = GetGuildRosterInfo(j)
	
					-- Find who was invited!
				    if name ~= nil then
					if name == player1 then
					local MyNewMember = player1
					
					for k = 1, #MyGuildNotesDataBase, 25 do
					    if MyNewMember == MyGuildNotesDataBase[k] then
						JUNK = year*315536000+month*2592000+day*86400+hour*3600
						MyDateInvited = date("%m/%d/%Y", time()-JUNK)
						MyGuildNotesDataBase[k+17] = MyDateInvited
						MyGuildNotesDataBase[k+19] = "Member"
					    end
					end


					-- Find who did the inviting!

	        			    for k = 1, MyNumEvents do
		   			    local type, player1, player2, rank, year, month, day, hour = GetGuildEventInfo(k)
						if type == "invite" then
						    if player2 == MyNewMember then
						    MyNewMemberInviter = player1
						    end
						end
					    end
					if MyNewMemberInviter == nil then MyNewMemberInviter = "Unknown" end
					--- Automatically add information to the public/officer notes ---					
					if MyGuildNotesVars.GNPUBOPTION == 1 then MyGNPublicNote = "Joined on "..MyDateInvited end
					if MyGuildNotesVars.GNPUBOPTION == 2 then MyGNPublicNote = "Joined on "..MyDateInvited.." @ level "..level end
					if MyGuildNotesVars.GNPUBOPTION == 3 then MyGNPublicNote = "Inv. by "..MyNewMemberInviter.." "..MyDateInvited end

					if MyGuildNotesVars.GNOFFOPTION == 1 then MyGNOfficerNote = "Joined on "..MyDateInvited end
					if MyGuildNotesVars.GNOFFOPTION == 2 then MyGNOfficerNote = "Joined on "..MyDateInvited.." @ level "..level end
					if MyGuildNotesVars.GNOFFOPTION == 3 then MyGNOfficerNote = "Inv. by "..MyNewMemberInviter.." "..MyDateInvited end
					
					if note == "" and MyGuildNotesVars.GNPUBOPTION ~= 4 then GuildRosterSetPublicNote(j, MyGNPublicNote) end
					if officernote == "" and MyGuildNotesVars.GNOFFOPTION ~= 4 then GuildRosterSetOfficerNote(j, MyGNOfficerNote) end

					end
				    end
				end
			    end
			end
			end

--------------------------------------------------------
--- THIS FUNCTION CAPTURES OLD PLAYERS THAT LEFT AND ---
--DELETED OR OTHERWISE MISSING PLAYERS FROM THE ROSTER--
--------------------------------------------------------

for i = 1, #MyGuildNotesDataBase, 25 do

if string.len(MyGuildNotesDataBase[i+1]) == 1 then level = "0"..MyGuildNotesDataBase[i+1] else level = MyGuildNotesDataBase[i+1] end
MyGuildNotesDB[(i+24)/25] = level.." "..MyGuildNotesDataBase[i].." "..MyGuildNotesDataBase[i+2]

if UnitIsInMyGuild(MyGuildNotesDataBase[i]) ~= 1 then -- missing player -- faction changes, deletions...etc.
if MyGuildNotesDataBase[i+18] ~= nil then
MYGNFOUND = 0
    for j = 1, #MyGuildNotesQuit do --	CHECK TO SEE IF WE HAVE THEM ON THE QUIT LIST ALREADY
	JUNK1, JUNK2, JUNK3 = string.split(" ", MyGuildNotesQuit[j], 3)
	if JUNK2 == MyGuildNotesDataBase[i] then MYGNFOUND = 1 end
    end
    if MYGNFOUND == 0 then -- THIS IS A NEW PERSON THAT LEFT THAT IS NOT IN THE LIST SO WE HAVE NO REAL IDEA WHEN THEY LEFT.
		if MyGuildNotesDataBase[i+18] == "" then
		MyDateQuit = date("%m/%d/%Y", time())
		MyGuildNotesDataBase[i+18] = MyDateQuit
		MyGuildNotesDataBase[i+19] = "Quit"
		end
	JUNK2, JUNK3, JUNK1 = string.split("/", MyGuildNotesDataBase[i+18], 3)
	JUNK = date("*t")
	JUNK.year = tonumber(JUNK1)
	JUNK.month = tonumber(JUNK2)
	JUNK.day = tonumber(JUNK3)
	JUNK1 = MyGuildNotesDataBase[i+1]
	JUNK2 = MyGuildNotesDataBase[i]
	JUNK3 = (time()-time(JUNK))/86400 -- days ago left
	if JUNK3 <= MyGuildNotesVars.MyGNQuitMax then MyGuildNotesQuit[#MyGuildNotesQuit+1] = JUNK3.." "..JUNK2.." "..JUNK1 end
    end

end
end
end

-- BUBBLE SORT --
for i = 1, #MyGuildNotesQuit do
    for j = 1, #MyGuildNotesQuit do
	JUNK1 = string.split(" ", MyGuildNotesQuit[i], 2)
	JUNK2 = string.split(" ", MyGuildNotesQuit[j], 2)
	JUNK1 = tonumber(JUNK1)
	JUNK2 = tonumber(JUNK2)
	if JUNK1 > JUNK2 then
	    JUNK = MyGuildNotesQuit[i]
	    MyGuildNotesQuit[i] = MyGuildNotesQuit[j]
	    MyGuildNotesQuit[j] = JUNK
	end
    end
end

for i = 1, #MyGuildNotesQuit do
JUNK1, JUNK2, JUNK3 = string.split(" ", MyGuildNotesQuit[i], 3)
day = tonumber(JUNK1)
if string.len(JUNK3) == 1 then JUNK3 = "0"..JUNK3 end
if day ~= 0 then MyGuildNotesQuit[i] = JUNK3.." "..JUNK2.." quit "..day.." days ago." end
if day >= 60 then MyGuildNotesQuit[i] = JUNK3.." "..JUNK2.." quit "..math.floor(day/30).." months ago." end
if day == 1 then MyGuildNotesQuit[i] = JUNK3.." "..JUNK2.." quit yesterday." end
if day == 0 then MyGuildNotesQuit[i] = JUNK3.." "..JUNK2.." quit today!" end
end


for i = 1, #MyGuildNotesDataBase, 25 do
if UnitIsInMyGuild(MyGuildNotesDataBase[i]) == 1 then
	JUNK2, JUNK3, JUNK1 = string.split("/", MyGuildNotesDataBase[i+17], 3)
	JUNK = date("*t")
	JUNK.year = tonumber(JUNK1)
	JUNK.month = tonumber(JUNK2)
	JUNK.day = tonumber(JUNK3)
	if JUNK.year ~= nil and JUNK.month ~= nil and JUNK.day ~= nil then
	JUNK1 = MyGuildNotesDataBase[i+1]
	JUNK2 = MyGuildNotesDataBase[i]
	JUNK3 = (time()-time(JUNK))/86400 -- days ago Joined
	if JUNK3 <= MyGuildNotesVars.MyGNJoinMax then m=m+1 MyGuildNotesJoin[m] = JUNK3.." "..JUNK2.." "..JUNK1 end
	end
end
end

-- BUBBLE SORT --
for i = 1, #MyGuildNotesJoin do
    for j = 1, #MyGuildNotesJoin do
	JUNK1 = string.split(" ", MyGuildNotesJoin[i], 2)
	JUNK2 = string.split(" ", MyGuildNotesJoin[j], 2)
	JUNK1 = tonumber(JUNK1)
	JUNK2 = tonumber(JUNK2)
	if JUNK1 > JUNK2 then
	    JUNK = MyGuildNotesJoin[i]
	    MyGuildNotesJoin[i] = MyGuildNotesJoin[j]
	    MyGuildNotesJoin[j] = JUNK
	end
    end
end

for i = 1, #MyGuildNotesJoin do
JUNK1, JUNK2, JUNK3 = string.split(" ", MyGuildNotesJoin[i], 3)
day = tonumber(JUNK1)
if string.len(JUNK3) == 1 then JUNK3 = "0"..JUNK3 end
if day ~= 0 then MyGuildNotesJoin[i] = JUNK3.." "..JUNK2.." joined "..day.." days ago." end
if day >= 60 then MyGuildNotesJoin[i] = JUNK3.." "..JUNK2.." joined "..math.floor(day/30).." months ago." end
if day == 1 then MyGuildNotesJoin[i] = JUNK3.." "..JUNK2.." joined yesterday." end
if day == 0 then MyGuildNotesJoin[i] = JUNK3.." "..JUNK2.." joined today!" end
end

--- DISPLAY UP TO THE LAST 50 POSSIBLE EVENTS FOR EACH CATEGORY FROM THE LOG
---------------------------------------------------
	z=#MyGuildNotesJoin-49
	c=1 
	for n = #MyGuildNotesJoin, z, -1 do
	if n <= 0 then MyGuildNotesJoins[c] = "" end
	if MyGuildNotesJoin[n] == nil then MyGuildNotesJoin[n] = "" end
	MyGuildNotesJoins[c] = MyGuildNotesJoin[n]
	c=c+1
	end
---------------------------------------------------
---------------------------------------------------
	z=#MyGuildNotesQuit-49
	c=1
	for n = #MyGuildNotesQuit, z, -1 do
	if n <= 0 then MyGuildNotesQuits[c] = "" end
	if MyGuildNotesQuit[n] == nil then MyGuildNotesQuit[n] = "" end
	MyGuildNotesQuits[c] = MyGuildNotesQuit[n]
	c=c+1
	end
---------------------------------------------------
---------------------------------------------------
	z=#MyGuildNotesRemove-49
	c=1
	for n = #MyGuildNotesRemove, z, -1 do
	if n <= 0 then MyGuildNotesRemoves[c] = "" end
	if MyGuildNotesRemove[n] == nil then MyGuildNotesRemove[n] = "" end
	MyGuildNotesRemoves[c] = MyGuildNotesRemove[n]
	c=c+1
	end
---------------------------------------------------
---------------------------------------------------

	elseif event == "CHAT_MSG_SYSTEM" then

	--- GRABBING THE GUILD CREATION DATE FROM THE SYSTEM ---

	__, JUNK, message = string.split(" ", message, 5)
	if JUNK == "created" then
	MyGuildNotesVars.GuildDate = string.split(",", message, 2)
	end

	--- THIS SHOULD ONLY FIRE AUTOMATICALLY THE FIRST TIME THE MOD IS RUN ---

	elseif event == "PLAYER_LOGOUT" then
	-- Save all of our options/locations
	return;

	else
--	print(event) -- Debugging Purposes
    end
else
end
end

--frame:RegisterAllEvents() -- Debugging Purposes
--frame:RegisterEvent("GUILD_NEWS_UPDATE")
frame:RegisterEvent("GUILD_EVENT_LOG_UPDATE")
frame:RegisterEvent("GUILD_ROSTER_UPDATE")
frame:RegisterEvent("PLAYER_LOGOUT")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("CHAT_MSG_SYSTEM")

frame:SetScript("OnEvent", WatchDog)

---------------------------------------------------------------------------


function GN:MyGNDBAlpha()
for i = 1, #MyGuildNotesDB do
    for j = 1, #MyGuildNotesDB do
	_, JUNK1 = string.split(" ", MyGuildNotesDB[i], 3)
	_, JUNK2 = string.split(" ", MyGuildNotesDB[j], 3)
	if JUNK1 < JUNK2 then
	    JUNK = MyGuildNotesDB[i]
	    MyGuildNotesDB[i] = MyGuildNotesDB[j]
	    MyGuildNotesDB[j] = JUNK
	end
    end
end
GN:MyGuildNotesRefresh()
end





local function MyonUpdate(self, elapsed)

      total = total + elapsed

if MyGuildNotesFrame ~= nil then

   if not MyGuildNotesFrame:IsVisible() and MyGuildNotesAreOpen == 1 then
	PlaySound("igCharacterInfoClose")
	MyGuildNotesAreOpen = 0
   end

    if MyPageShown == 1 and MyGuildNotesText[1] ~= MyGuildNotesJoins[1] then GN:MyGuildNotesRefresh() end
    if MyPageShown == 2 and MyGuildNotesText[1] ~= MyGuildNotesQuits[1] then GN:MyGuildNotesRefresh() end
    if MyPageShown == 3 and MyGuildNotesText[1] ~= MyGuildNotesRemoves[1] then GN:MyGuildNotesRefresh() end
    if MyPageShown == 4 and MyGuildNotesText[1] ~= MyGuildNotesOnline[1] then GN:MyGuildNotesRefresh() end
    if MyPageShown == 5 and MyGuildNotesText[1] ~= MyGuildNotesDB[1] then GN:MyGNDBAlpha() GN:MyGuildNotesRefresh() end

end
	--- CALLING THE GUILD ROSTER EVERY THREE SECONDS UNTIL CHANGE IS CONFIRMED ---
	--- THIS ONLY FIRES FOR INTERNAL UPDATES, NOT FOR UPDATES MADE BY OTHER USERS ---
	if total >= 3 then
	if MyGNEdit == 1 then GuildRoster() end	
	total = 0 end

end

local f = CreateFrame("frame")
f:SetScript("OnUpdate", MyonUpdate)
----------------------------------------------------------------------------


MyGNConfigOptions = {
	name = "MyGuildNotes "..version,
	type = 'group',
	args = {
		CONFIGDESCRIPTION = {
			order = 10,
			type = "description",
			name = "    Graphical User Interface\n",
			cmdHidden = true
			},
		NOTESDESCRIPTION = {
			order = 20,
			type = "description",
			name = "    Automatic Notes Options\n",
			cmdHidden = true
			},
		HISTORYDESCRIPTION = {
			order = 30,
			type = "description",
			name = "    History Display Options\n",
			cmdHidden = true
			},
		SETTINGSDESCRIPTION = {
			order = 40,
			type = "description",
			name = "    Scroll Speed Options\n",
			cmdHidden = true
			},
		CONFIG = {
			order = 11,
			name = "TOGGLE",
			desc = "Opens MyGuildNotes GUI",
			type = 'execute',
			func = function()
			GN:CFToggle()
			end
			},
		RESET = {
			order = 12,
			name = "RESET ICON",
			desc = "Resets the location of the Toggle Icon to the default position. \nMay not take effect until the next time you log in or do a /console reloadui",
			type = 'execute',
			func = function()
			   if not MyGuildNotesICONB then
			   GN:LoadGUI()
		           end
			MyGuildNotesVars.ICON = 0
			MyGuildNotesVars.ICONBa = "CENTER"
			MyGuildNotesVars.ICONBb = "Minimap"
			MyGuildNotesVars.ICONBc = "CENTER"
			MyGuildNotesVars.ICONBx = 26
		 	MyGuildNotesVars.ICONBy = -165
			MyGuildNotesICON:ClearAllPoints()
			MyGuildNotesICON:Hide()
			MyGuildNotesICON:SetPoint(MyGuildNotesVars.ICONBa, MyGuildNotesVars.ICONBb, MyGuildNotesVars.ICONBc, MyGuildNotesVars.ICONBx, MyGuildNotesVars.ICONBy)
			MyGuildNotesICON:Show()
			MyGuildNotesICONB:Show()
			end
			},
		DISABLE = {
			order = 13,
			name = "TOGGLE ICON",
			desc = "Hide/Show the Toggle Icon",
			type = 'execute',
			func = function()
			   if not MyGuildNotesICONB then
			   GN:LoadGUI()
		           end
			if MyGuildNotesICONB:IsVisible() then
			MyGuildNotesVars.ICON = 1
			MyGuildNotesICONB:Hide()
			else
			MyGuildNotesVars.ICON = 0
			MyGuildNotesICONB:Show()
			end
			end
			},
		PUBLIC = {
			order = 21,
			name = "   PUBLIC MESSAGE OPTIONS",
			type = 'select',
			values = {
			"Date Joined",
			"Date Joined w/Level",
			"Inviter & Date Joined",
			"None",
			},
			set = function(info, value)
			MyGuildNotesVars.GNPUBOPTION = value
			end,
			get = function()
			return MyGuildNotesVars.GNPUBOPTION
			end
			},
		OFFICER = {
			order = 22,
			name = "   OFFICER MESSAGE OPTIONS",
			type = 'select',
			values = {
			"Date Joined",
			"Date Joined w/Level",
			"Inviter & Date Joined",
			"None",
			},
			set = function(info, value)
			MyGuildNotesVars.GNOFFOPTION = value
			end,
			get = function()
			return MyGuildNotesVars.GNOFFOPTION
			end
			},
		MAXKEEPJOIN = {
			order = 31,
			name = "   JOIN HISTORY DISPLAYED",
			type = 'select',
			values = {
			"1 Month",
			"2 Months",
			"3 Months",
			"4 Months",
			"5 Months",
			"6 Months",
			},
			set = function(info, value)
			MyGuildNotesVars.MyGNJoinMax = value*30
			end,
			get = function()
			JUNK = (MyGuildNotesVars.MyGNJoinMax/30)
			return JUNK
			end
			},
		MAXKEEPQUIT = {
			order = 32,
			name = "   QUIT HISTORY DISPLAYED",
			type = 'select',
			values = {
			"1 Month",
			"2 Months",
			"3 Months",
			"4 Months",
			"5 Months",
			"6 Months",
			},
			set = function(info, value)
			MyGuildNotesVars.MyGNQuitMax = value*30
			end,
			get = function()
			JUNK = (MyGuildNotesVars.MyGNQuitMax/30)
			return JUNK
			end
			},
		MAXKEEPKICK = {
			order = 33,
			name = "   KICK HISTORY DISPLAYED",
			type = 'select',
			values = {
			"1 Month",
			"2 Months",
			"3 Months",
			"4 Months",
			"5 Months",
			"6 Months",
			},
			set = function(info, value)
			MyGuildNotesVars.MyGNKickMax = value*30
			end,
			get = function()
			JUNK = (MyGuildNotesVars.MyGNKickMax/30)
			return JUNK
			end
			},
		SCROLLSPEED = {
			order = 41,
			name = "   SCROLL SPEED",
			type = 'range',
			min = 1,
			max = 13,
			set = function(info, value)
			MyGuildNotesVars.DELTA = math.floor(value)
			end,
			get = function() return MyGuildNotesVars.DELTA end
			}
		},
}

function GN:LoadGUI()
	if MyGNGUIShown ~= 1 and MyGNVariablesLoaded == 1 then
	GN:ShowGUI()
	GN:MyGNInfoFrames()
	MyGNGUIShown = 1
	GuildRoster()
	end
end

function GN:OnInitialize()

	GN:RegisterChatCommand("MyGN", "Slash")

	local AC = LibStub('AceConfig-3.0')
	local ACD = LibStub('AceConfigDialog-3.0')

	AC:RegisterOptionsTable("MyGuildNotes", MyGNConfigOptions)
	MyGuildNotes.optionsFrame = ACD:AddToBlizOptions("MyGuildNotes", "MyGuildNotes")
	MyGuildNotesVars.tooltip = YELLOW..ModName..WHITE.."\nLeft-click to "..GREEN.."Toggle.\n"..WHITE.."Right-click to "..GREEN.."Drag."
	MyGuildNotesVars.tooltip2 = WHITE.."\nLeft-click to "..GREEN.."Select Record.\n"..WHITE.."Right-click to "..GREEN.."Deselect and Continue Browsing."

end

function GN:SetClassColor(class)

CLASSCOLOR = "|cFFFFD700" -- Gold Default

if class == "DEATHKNIGHT" then CLASSCOLOR	= "|cffC41F3B" end -- Red 
if class == "DRUID" then CLASSCOLOR		= "|cffFF7D0A" end -- Orange 
if class == "HUNTER" then CLASSCOLOR		= "|cffABD473" end -- Green
if class == "MAGE" then CLASSCOLOR		= "|cff69CCF0" end -- Light Blue
if class == "MONK" then CLASSCOLOR		= "|cff00FF96" end -- Jade green
if class == "PALADIN" then CLASSCOLOR		= "|cffF58CBA" end -- Pink 
if class == "PRIEST" then CLASSCOLOR		= "|cffFFFFFF" end -- White 
if class == "ROGUE" then CLASSCOLOR		= "|cffFFF569" end -- Light yellow 
if class == "SHAMAN" then CLASSCOLOR		= "|cff0070DE" end -- Blue 
if class == "WARLOCK" then CLASSCOLOR		= "|cff9482C9" end -- Purple 
if class == "WARRIOR" then CLASSCOLOR		= "|cffC79C6E" end -- Tan


if class == "Death Knight" then CLASSCOLOR	= "|cffC41F3B" end -- Red 
if class == "Druid" then CLASSCOLOR		= "|cffFF7D0A" end -- Orange 
if class == "Hunter" then CLASSCOLOR		= "|cffABD473" end -- Green
if class == "Mage" then CLASSCOLOR		= "|cff69CCF0" end -- Light Blue
if class == "Monk" then CLASSCOLOR		= "|cff00FF96" end -- Jade green
if class == "Paladin" then CLASSCOLOR		= "|cffF58CBA" end -- Pink 
if class == "Priest" then CLASSCOLOR		= "|cffFFFFFF" end -- White 
if class == "Rogue" then CLASSCOLOR		= "|cffFFF569" end -- Light yellow 
if class == "Shaman"  then CLASSCOLOR		= "|cff0070DE" end -- Blue 
if class == "Warlock" then CLASSCOLOR		= "|cff9482C9" end -- Purple 
if class == "Warrior" then CLASSCOLOR		= "|cffC79C6E" end -- Tan

end

function GN:Slash(msg)
MyType = type(tonumber(msg))
	if msg then

		if strlower(msg) == "toggle" then
			GN:CFToggle()
			return;

		else
		GN:Print("|cff00CC00Format:|r\n\"/MyGN Toggle\" toggles the GUI")
		end
	end
end

function GN:MyGuildNotesRefresh()
wipe(MyGuildNotesText)

local MyGNMaxTable = 1000
local MYGNSTEP = 1
local l = 0
  for i = 1, MyGNMaxTable, MYGNSTEP do

MyGNIndex[i] = 0

    if MyPageShown == 1 then if MyGuildNotesJoins[i] ~= "" then MyGuildNotesText[i] = MyGuildNotesJoins[i] end end
    if MyPageShown == 2 then if MyGuildNotesQuits[i] ~= "" then MyGuildNotesText[i] = MyGuildNotesQuits[i] end end
    if MyPageShown == 3 then if MyGuildNotesRemoves[i] ~= "" then MyGuildNotesText[i] = MyGuildNotesRemoves[i] end end
    if MyPageShown == 4 then if MyGuildNotesOnline[i] ~= nil then MyGuildNotesText[i] = MyGuildNotesOnline[i] end end
    if MyPageShown == 5 then if MyGuildNotesDB[i] ~= "" then MyGuildNotesText[i] = MyGuildNotesDB[i] end end

    if MyGuildNotesText[i] ~= nil and MyGuildNotesDataBaseLoad == 1 then
    _, JUNK = string.split(" ", MyGuildNotesText[i], 3)
      for k = 1, #MyGuildNotesDataBase, 25 do
        if JUNK == MyGuildNotesDataBase[k] then
	MyGNIndex[i] = k
	end
      end
    end
  end

  if MyGNDisplayTable1 ~= nil then GN:MyGNDisplayText() end

end

function GN:MyGuildNotesSave()
MyGuildNotesVars.ICONBa, MyGuildNotesVars.ICONBb, MyGuildNotesVars.ICONBc, MyGuildNotesVars.ICONBx, MyGuildNotesVars.ICONBy = MyGuildNotesICONB:GetPoint()
end

function GN:MyGNInfoFrames()

local MyGNInfoFrame = CreateFrame("Frame", "MyGNInfoFrame", MyGuildNotesFrame)
MyGNInfoFrame:SetFrameStrata("HIGH")
MyGNInfoFrame:SetPoint("TOPRIGHT", MyGuildNotesFrame, "TOPLEFT")
MyGNInfoFrame:SetWidth(384)
MyGNInfoFrame:SetHeight(384)
MyGNInfoFrame:Hide()
MyGNInfoFrame:SetHitRectInsets(0, 0, 0, 0)

local GNInfotextureR = MyGNInfoFrame:CreateTexture(nil, "BACKGROUND", MyGNInfoFrame)
GNInfotextureR:SetTexture("Interface/Stationery/StationeryTest2")
GNInfotextureR:SetSize(48,384)
GNInfotextureR:SetPoint("TOPLEFT", MyGNInfoFrame, "TOPRIGHT", -25, -25)

local GNInfotextureL = MyGNInfoFrame:CreateTexture(nil, "BACKGROUND", MyGNInfoFrame)
GNInfotextureL:SetTexture("Interface/Stationery/StationeryTest1")
GNInfotextureL:SetSize(336,384)
GNInfotextureL:SetPoint("TOPRIGHT", MyGNInfoFrame, "TOPRIGHT", -25, -25)

local GNInfoTitle = MyGNInfoFrame:CreateFontString("GNInfoTitle", "ARTWORK")
GNInfoTitle:SetFont("Fonts\\FRIZQT__.ttf", 26, "OUTLINE")
GNInfoTitle:SetPoint("TOP", 10, -27)
GNInfoTitle:SetTextColor(1, 1, 0)

local GNInfoSummary = MyGNInfoFrame:CreateFontString("GNInfoSummary", "ARTWORK")
GNInfoSummary:SetFont("Fonts\\ARIALN.ttf", 18)
GNInfoSummary:SetPoint("TOP", 10, -60)
GNInfoSummary:SetTextColor(0, 0, 1)

MyGNPublicNoteTitle = MyGNInfoFrame:CreateFontString("MyGNPublicNoteTitle", "ARTWORK")
MyGNPublicNoteTitle:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNPublicNoteTitle:SetPoint("TOP", 15, -85)
MyGNPublicNoteTitle:SetTextColor(0, 0, 1)
MyGNPublicNoteTitle:SetText("Public Note       31 Characters Max")

MyGNPublicNoteInput = CreateFrame("EditBox", "MyGNPublicNoteInput", MyGNInfoFrame, "InputBoxTemplate")
MyGNPublicNoteInput:SetWidth(293)
MyGNPublicNoteInput:SetHeight(25)
MyGNPublicNoteInput:SetPoint("TOPLEFT", 60, -100)
MyGNPublicNoteInput:SetMaxLetters(31)
MyGNPublicNoteInput:SetAutoFocus(false)
MyGNPublicNoteInput:SetScript("OnEnterPressed", function(self)
if UnitIsInMyGuild(MYGNINDEX) == 1 then
GN:MyGNPublicNoteChanged(MyGNPublicNoteInput:GetText(), MYGNINDEX)
MyGNPublicNote = MyGNPublicNoteInput:GetText()
else
print(YELLOW.."Unable to change notes on non-members!")
MyGNPublicNoteInput:SetText(MyGNPublicNote)
end
MyGNPublicNoteInput:ClearFocus()
end)
MyGNPublicNoteInput:SetScript("OnEditFocusLost", function(self)
MyGNPublicNoteInput:SetText(MyGNPublicNote)
end)

MyGNOfficerNoteTitle = MyGNInfoFrame:CreateFontString("MyGNOfficerNoteTitle", "ARTWORK")
MyGNOfficerNoteTitle:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNOfficerNoteTitle:SetPoint("TOP", 12, -125)
MyGNOfficerNoteTitle:SetTextColor(0, 0, 1)
MyGNOfficerNoteTitle:SetText("Officer Note       31 Characters Max")

MyGNOfficerNoteInput = CreateFrame("EditBox", "MyGNOfficerNoteInput", MyGNInfoFrame, "InputBoxTemplate")
MyGNOfficerNoteInput:SetWidth(293)
MyGNOfficerNoteInput:SetHeight(25)
MyGNOfficerNoteInput:SetPoint("TOPLEFT", 60, -140)
MyGNOfficerNoteInput:SetMaxLetters(31)
MyGNOfficerNoteInput:SetAutoFocus(false)
MyGNOfficerNoteInput:SetScript("OnEnterPressed", function(self)
if UnitIsInMyGuild(MYGNINDEX) == 1 then
GN:MyGNOfficerNoteChanged(MyGNOfficerNoteInput:GetText(), MYGNINDEX)
MyGNOfficerNote = MyGNOfficerNoteInput:GetText()
else
print(YELLOW.."Unable to change notes on non-members!")
MyGNOfficerNoteInput:SetText(MyGNOfficerNote)
end
MyGNOfficerNoteInput:ClearFocus()
end)
MyGNOfficerNoteInput:SetScript("OnEditFocusLost", function(self)
MyGNOfficerNoteInput:SetText(MyGNOfficerNote)
end)

MyGNJoinedDate = MyGNInfoFrame:CreateFontString("MyGNJoinedDate", "ARTWORK")
MyGNJoinedDate:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNJoinedDate:SetPoint("TOPLEFT", 60, -389)
MyGNJoinedDate:SetTextColor(0, 0, 1)

MyGNQuitDate = MyGNInfoFrame:CreateFontString("MyGNQuitDate", "ARTWORK")
MyGNQuitDate:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNQuitDate:SetPoint("TOPLEFT", 235, -389)
MyGNQuitDate:SetTextColor(0, 0, 1)

MyGNPrivateNoteTitle = MyGNInfoFrame:CreateFontString("MyGNPrivateNoteTitle", "ARTWORK")
MyGNPrivateNoteTitle:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNPrivateNoteTitle:SetPoint("TOP", 12, -165)
MyGNPrivateNoteTitle:SetTextColor(0, 0, 1)
MyGNPrivateNoteTitle:SetText("Private Notes    255 Characters Max")

MyGNPrivateNoteInput = CreateFrame("EditBox", "MyGNPrivateNoteInput", MyGNInfoFrame, "InputBoxTemplate")
MyGNPrivateNoteInput:SetWidth(293)
MyGNPrivateNoteInput:SetHeight(25)
MyGNPrivateNoteInput:SetPoint("TOPLEFT", 60, -180)
MyGNPrivateNoteInput:SetMaxLetters(255)
MyGNPrivateNoteInput:SetAutoFocus(false)
MyGNPrivateNoteInput:SetScript("OnEnterPressed", function(self)
GN:MyGNPrivateNoteChanged(MyGNPrivateNoteInput:GetText(), MYGNINDEX)
MyGNPrivateNote = MyGNPrivateNoteInput:GetText()
MyGNPrivateNoteInput:ClearFocus()
end)
MyGNPrivateNoteInput:SetScript("OnEditFocusLost", function(self)
MyGNPrivateNoteInput:SetText(MyGNPrivateNote)
end)

MyGNAliasTitle = MyGNInfoFrame:CreateFontString("MyGNAliasTitle", "ARTWORK")
MyGNAliasTitle:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasTitle:SetPoint("TOP", 10, -205)
MyGNAliasTitle:SetTextColor(0, 0, 1)
MyGNAliasTitle:SetText("   Main                               Add Alts")

MyGNAliasInput = CreateFrame("EditBox", "MyGNAliasInput", MyGNInfoFrame, "InputBoxTemplate")
MyGNAliasInput:SetWidth(100)
MyGNAliasInput:SetHeight(25)
MyGNAliasInput:SetPoint("TOPLEFT", 60, -220)
MyGNAliasInput:SetMaxLetters(16)
MyGNAliasInput:SetAutoFocus(false)
MyGNAliasInput:SetScript("OnEnterPressed", function(self)
GN:MyGNAliasChanged(MyGNAliasInput:GetText(), MyGNOldAlias, MYGNINDEX)
MyGNAlias = MyGNAliasInput:GetText()
MyGNAliasInput:ClearFocus()
end)
MyGNAliasInput:SetScript("OnEditFocusLost", function(self)
MyGNAliasInput:SetText(MyGNAlias)
end)

MyGNAltsInput = CreateFrame("EditBox", "MyGNAltsInput", MyGNInfoFrame, "InputBoxTemplate")
MyGNAltsInput:SetWidth(100)
MyGNAltsInput:SetHeight(25)
MyGNAltsInput:SetPoint("TOPLEFT", 253, -220)
MyGNAltsInput:SetMaxLetters(16)
MyGNAltsInput:SetAutoFocus(false)
MyGNAltsInput:SetScript("OnEnterPressed", function(self)
GN:MyGNAltsChanged(MyGNAltsInput:GetText(), MyGNAlias, MYGNINDEX)
MyGNAltsInput:ClearFocus()
end)
MyGNAltsInput:SetScript("OnEditFocusLost", function(self)
MyGNAltsInput:SetText("")
end)

MyGNJoinedDateTitle = MyGNInfoFrame:CreateFontString("MyGNJoinedDateTitle", "ARTWORK")
MyGNJoinedDateTitle:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNJoinedDateTitle:SetPoint("TOPLEFT", 50, -389)
MyGNJoinedDateTitle:SetTextColor(0, 0, 1)
MyGNJoinedDateTitle:SetText("Joined:")

MyGNJoinedDateInput = CreateFrame("EditBox", "MyGNJoinedNoteInput", MyGNInfoFrame, "InputBoxTemplate")
MyGNJoinedDateInput:SetWidth(70)
MyGNJoinedDateInput:SetHeight(25)
MyGNJoinedDateInput:SetPoint("TOPLEFT", 125, -384)
MyGNJoinedDateInput:SetMaxLetters(10)
MyGNJoinedDateInput:SetAutoFocus(false)
MyGNJoinedDateInput:SetScript("OnEnterPressed", function(self)
if MyGNJoinedDateInput:GetText() ~= "" then
JUNK1, JUNK2, JUNK3 = string.split("/", MyGNJoinedDateInput:GetText(), 3)
if JUNK3 ~= nil then
if string.len(JUNK3) == 4 then
GN:MyGNJoinedDateChanged(MyGNJoinedDateInput:GetText(), MYGNINDEX)
MyGNJoinedDate = MyGNJoinedDateInput:GetText()
else
print(WHITE.."MyGuildNews:  "..GREEN.."Date Format mm/dd/yyyy")
end
end
else
GN:MyGNJoinedDateChanged(MyGNJoinedDateInput:GetText(), MYGNINDEX)
MyGNJoinedDate = MyGNJoinedDateInput:GetText()
end
MyGNJoinedDateInput:ClearFocus()
end)
MyGNJoinedDateInput:SetScript("OnEditFocusLost", function(self)
MyGNJoinedDateInput:SetText(MyGNJoinedDate)
end)

MyGNQuitDate = MyGNInfoFrame:CreateFontString("MyGNQuitDate", "ARTWORK")
MyGNQuitDate:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNQuitDate:SetPoint("TOPLEFT", 235, -389)
MyGNQuitDate:SetTextColor(0, 0, 1)

MyGNAliasList6 = MyGNInfoFrame:CreateFontString("MyGNAliasList6", "ARTWORK")
MyGNAliasList6:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasList6:SetPoint("TOPLEFT", 55, -260)
MyGNAliasList6:SetTextColor(0, 0, 1)

MyGNAliasList7 = MyGNInfoFrame:CreateFontString("MyGNAliasList7", "ARTWORK")
MyGNAliasList7:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasList7:SetPoint("TOPLEFT", 247, -260)
MyGNAliasList7:SetTextColor(0, 0, 1)

MyGNAliasList8 = MyGNInfoFrame:CreateFontString("MyGNAliasList8", "ARTWORK")
MyGNAliasList8:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasList8:SetPoint("TOPLEFT", 55, -280)
MyGNAliasList8:SetTextColor(0, 0, 1)

MyGNAliasList9 = MyGNInfoFrame:CreateFontString("MyGNAliasList9", "ARTWORK")
MyGNAliasList9:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasList9:SetPoint("TOPLEFT", 247, -280)
MyGNAliasList9:SetTextColor(0, 0, 1)

MyGNAliasList10 = MyGNInfoFrame:CreateFontString("MyGNAliasList10", "ARTWORK")
MyGNAliasList10:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasList10:SetPoint("TOPLEFT", 55, -300)
MyGNAliasList10:SetTextColor(0, 0, 1)

MyGNAliasList11 = MyGNInfoFrame:CreateFontString("MyGNAliasList11", "ARTWORK")
MyGNAliasList11:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasList11:SetPoint("TOPLEFT", 247, -300)
MyGNAliasList11:SetTextColor(0, 0, 1)

MyGNAliasList12 = MyGNInfoFrame:CreateFontString("MyGNAliasList12", "ARTWORK")
MyGNAliasList12:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasList12:SetPoint("TOPLEFT", 55, -320)
MyGNAliasList12:SetTextColor(0, 0, 1)

MyGNAliasList13 = MyGNInfoFrame:CreateFontString("MyGNAliasList13", "ARTWORK")
MyGNAliasList13:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasList13:SetPoint("TOPLEFT", 247, -320)
MyGNAliasList13:SetTextColor(0, 0, 1)

MyGNAliasList14 = MyGNInfoFrame:CreateFontString("MyGNAliasList14", "ARTWORK")
MyGNAliasList14:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasList14:SetPoint("TOPLEFT", 55, -340)
MyGNAliasList14:SetTextColor(0, 0, 1)

MyGNAliasList15 = MyGNInfoFrame:CreateFontString("MyGNAliasList15", "ARTWORK")
MyGNAliasList15:SetFont("Fonts\\FRIZQT__.ttf", 16)
MyGNAliasList15:SetPoint("TOPLEFT", 247, -340)
MyGNAliasList15:SetTextColor(0, 0, 1)

end

function GN:MyGNAltsChanged(MyGNAlts, MyGNAlias, MYGNINDEX)

if MyGNAlts ~= MYGNINDEX then -- preventing you from setting yourself as an alt
MYGNFOUND = 0
	if MyGNAlts ~= "" then
		MyGNAlts = strlower(MyGNAlts)
		JUNK1 = string.sub(MyGNAlts, 1, 1)
		JUNK1 = strupper(JUNK1)
		JUNK2 = string.sub(MyGNAlts,2, -1)
		MyGNAlts = JUNK1..JUNK2
	end
    for i = 1, #MyGuildNotesDataBase, 25 do
	if MyGuildNotesDataBase[i] == MyGNAlts then
		if MyGuildNotesDataBase[i+5] == "" then
		MyGuildNotesDataBase[i+5] = MyGNAlias	-- Add this characters' Alias information to the Alt
		print(WHITE.."MyGuildNews:  "..GREEN.."Alt information for "..WHITE..MyGNAlts..GREEN.." added.")
		MYGNFOUND = 1
		end
		
		if MyGuildNotesDataBase[i+5] == MyGNAlias and MYGNFOUND ~= 1 then
		print(WHITE.."MyGuildNews:  "..GREEN.."That character is already assigned to that Main.")
		MYGNFOUND = 1
		end

		if MYGNFOUND == 0 then
		print(WHITE.."MyGuildNews:  "..GREEN.."You must erase the Main on that character before trying to assign a new one.")
		MYGNFOUND = 1
		end
	end
	if MyGNAlias == MyGuildNotesDataBase[i] and UnitIsInMyGuild(MyGNAlts) == 1 then -- Found Main

		if MyGuildNotesDataBase[i+5] == "" then
		MyGuildNotesDataBase[i+5] = MyGNAlias 	-- Set the related toon information
		print(WHITE.."MyGuildNews:  "..GREEN.."Main information for "..WHITE..MyGNAlias..GREEN.." added.")
		end

		MYGNFOUND = 0
		for i2 = 1, 10 do
		    if MyGuildNotesDataBase[i+5+i2] == MyGNAlts then
		    MYGNFOUND = 1
		    end
		end

		for i2 = 1, 10 do	
		    if MyGuildNotesDataBase[i+5+i2] == "" and MYGNFOUND ~= 1 then
		    MyGuildNotesDataBase[i+5+i2] = MyGNAlts
		    MYGNFOUND = 1
		    end
		end
	end
	
    end
    if MYGNFOUND == 0 then print(WHITE.."MyGuildNews:  "..YELLOW..MyGNAlts..GREEN.." not found in the guild.") end
end
GN:MyGNAltsSync()
end

function GN:MyGNAliasChanged(MyGNAlias, MyGNOldAlias, MYGNINDEX)
	if MyGNAlias ~= "" then
		MyGNAlias = strlower(MyGNAlias)
		JUNK1 = string.sub(MyGNAlias, 1, 1)
		JUNK1 = strupper(JUNK1)
		JUNK2 = string.sub(MyGNAlias,2, -1)
		MyGNAlias = JUNK1..JUNK2
	end
if UnitIsInMyGuild(MyGNAlias) == 1 or MyGNAlias == "" then
    for i = 1, #MyGuildNotesDataBase, 25 do

	if MyGuildNotesDataBase[i] == MYGNINDEX then
	    MyGuildNotesDataBase[i+5] = MyGNAlias	-- Add this characters' Alias information
	    if MyGNAlias ~= "" then
	    print(WHITE.."MyGuildNews:  "..GREEN.."Main information for "..WHITE..MYGNINDEX..GREEN.." changed to "..WHITE..MyGNAlias..".")
	    else
	    print(WHITE.."MyGuildNews:  "..GREEN.."Main information for "..WHITE..MYGNINDEX..GREEN.." erased.")
	    MyGuildNotesDataBase[i+6] = ""
	    MyGuildNotesDataBase[i+7] = ""
	    MyGuildNotesDataBase[i+8] = ""
	    MyGuildNotesDataBase[i+9] = ""
	    MyGuildNotesDataBase[i+10] = ""
	    MyGuildNotesDataBase[i+11] = ""
	    MyGuildNotesDataBase[i+12] = ""
	    MyGuildNotesDataBase[i+13] = ""
	    MyGuildNotesDataBase[i+14] = ""
	    MyGuildNotesDataBase[i+15] = ""

	    end
	end

	if  MyGNOldAlias == MyGuildNotesDataBase[i] and MyGNAlias == "" then -- Found Main - Now we must erase this Alt from the list
		for i2 = 1, 10 do
		    if MyGuildNotesDataBase[i+5+i2] == MYGNINDEX then
			MyGuildNotesDataBase[i+5+i2] = ""
		    end
		end
	end

	if UnitIsInMyGuild(MYGNINDEX) == 1 then
	  if MyGNAlias ~= MYGNINDEX then --  Makes sure that we dont' set ourselves as an Alt also
	    if MyGNAlias == MyGuildNotesDataBase[i] then -- Found Main
		if MyGuildNotesDataBase[i+5] == "" then
		MyGuildNotesDataBase[i+5] = MyGNAlias 	-- Set the related toon information
		print(WHITE.."MyGuildNews:  "..GREEN.."Main information for "..WHITE..MyGNAlias..GREEN.." added.")
		end

		MYGNFOUND = 0
		for i2 = 1, 10 do
		    if MyGuildNotesDataBase[i+5+i2] == MYGNINDEX then
		    MYGNFOUND = 1
		    end
		end

		for i2 = 1, 10 do	
		    if MyGuildNotesDataBase[i+5+i2] == "" and MYGNFOUND ~= 1 then
		    MyGuildNotesDataBase[i+5+i2] = MYGNINDEX
		    MYGNFOUND = 1
		    end
		end
	    end
	  end
	end
    end
else
print(WHITE.."MyGuildNews:  "..GREEN.."Main must be a current Guild Member.")
end
GN:MyGNAltsSync()
end

function GN:MyGNAltsSync() -- Sync the Alt list with the Main list
for i = 1, #MyGuildNotesDataBase, 25 do
    if MyGuildNotesDataBase[i] == MyGuildNotesDataBase[i+5] then -- We found a Main!
	for i2 = 1, 10 do -- Go through the Alts list and Sync
	    for i3 = 1, #MyGuildNotesDataBase, 25 do
		if MyGuildNotesDataBase[i+5+i2] == MyGuildNotesDataBase[i3] then -- Found an Alt to Sync
		    for i4 = 1, 10 do
		    MyGuildNotesDataBase[i3+5+i4] = MyGuildNotesDataBase[i+5+i4] -- Syncing the list
		    end
		end
	    end
	end
    end
end
end

function GN:MyGNJoinedDateChanged(MyGNJoinedDate, MYGNINDEX)

    for i = 1, #MyGuildNotesDataBase, 25 do
	if MyGuildNotesDataBase[i] == MYGNINDEX then
	MyGuildNotesDataBase[i+17] = MyGNJoinedDate
	end
    end
end

function GN:MyGNPrivateNoteChanged(MyGNAdditionalNote, MYGNINDEX)

    for i = 1, #MyGuildNotesDataBase, 25 do
	if MyGuildNotesDataBase[i] == MYGNINDEX then
	MyGuildNotesDataBase[i+16] = MyGNAdditionalNote
	end
    end
end

function GN:MyGNPublicNoteChanged(MyGNPublicNote, MYGNINDEX)
MyGuildNotesVars.MyNumMembers = GetNumGuildMembers()
    for i = 1, MyGuildNotesVars.MyNumMembers do
name, rankName, rankIndex, level, class, zone, note, onote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR = GetGuildRosterInfo(i)
	if name == MYGNINDEX then 
	GuildRosterSetPublicNote(i, MyGNPublicNote)
	MyGNEdit = 1
	end
    end
end

function GN:MyGNOfficerNoteChanged(MyGNOfficerNote, MYGNINDEX)
MyGuildNotesVars.MyNumMembers = GetNumGuildMembers()
    for i = 1, MyGuildNotesVars.MyNumMembers do
name, rankName, rankIndex, level, class, zone, note, onote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR = GetGuildRosterInfo(i)
	if name == MYGNINDEX then 
	GuildRosterSetOfficerNote(i, MyGNOfficerNote)
	MyGNEdit = 1
	end
    end
end

function GN:MyGNDisplayTables()

for Q = 1, 15 do

    if Q == 1 then

	local MyGNDisplayTable = CreateFrame("Button", "MyGNDisplayTable1", MyGuildNotesFrame, "SecureHandlerClickTemplate")
	MyGNDisplayTable:SetID(Q)
	MyGNDisplayTable:SetFrameStrata("MEDIUM")
	MyGNDisplayTable:SetSize(320,20)
	MyGNDisplayTable:SetPoint("TOPLEFT", 25, -130)
	MyGNDisplayTable:SetHitRectInsets(0, 0, 0, 0)
	MyGNDisplayTable:SetHighlightTexture("Interface/QUESTFRAME/UI-QuestTitleHighlight")
	MyGNDisplayTable:EnableMouse(true)
	MyGNDisplayTable:RegisterForClicks("AnyDown")
	MyGNDisplayTable:Show()

	MyGNDisplayTable:SetScript("OnClick", function(self, button, down)
	if button == "LeftButton" and MyGNInfoFrameOpen == 0 then
	if MyGNIndex[Q] ~= 0 then

	MyGNInfoFrameOpen = 1
	MYGNINDEX = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])]
	MyGNPublicNote = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+3]
	MyGNOfficerNote = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+4]
	MyGNPrivateNote = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+16]
	MyGNJoinedDate = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+17]
	MyGNAlias = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+5]
	MyGNOldAlias = MyGNAliasInput:GetText()
	end
	else
	MyGNInfoFrameOpen = 0
	MyGNInfoFrame:Hide()
	end

	if button == "RightButton" then 
	MyGNInfoFrameOpen = 0
	MyGNInfoFrame:Hide()
	end

	end)

	MyGNDisplayTable:SetScript("OnEnter", function()
	if MyGNIndex[Q+MyGNDelta] ~= 0 then
	if MyGNInfoFrameOpen ~= 1 then

	GNInfoTitle:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])])
	GNInfoSummary:SetText("Level "..MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+1].." "..MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+2])
	MyGNPublicNoteInput:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+3])
	MyGNOfficerNoteInput:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+4])
	if MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+17] ~= "" then MyGNJoinedDateInput:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+17]) else MyGNJoinedDateInput:SetText("mm/dd/yyyy") end
	MyGNPrivateNoteInput:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+16])
	MyGNAliasInput:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+5])
	MyGNAliasList6:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+6])
	MyGNAliasList7:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+7])
	MyGNAliasList8:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+8])
	MyGNAliasList9:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+9])
	MyGNAliasList10:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+10])
	MyGNAliasList11:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+11])
	MyGNAliasList12:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+12])
	MyGNAliasList13:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+13])
	MyGNAliasList14:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+14])
	MyGNAliasList15:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+15])


	if MyPageShown == 1 or MyPageShown == 4 then
	MyGNQuitDate:SetText("")
	MyGNInfoFrame:Show()
	end

	if MyPageShown == 2 or MyPageShown == 3 or MyPageShown == 5 then
	MyGNQuitDate:SetText("Left: "..MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+18])
	MyGNInfoFrame:Show()		
	end

	end
	ItemRefTooltip:SetOwner(MyGuildNotesFrame, "MyGuildNotesFrame", 0, -475)
	ItemRefTooltip:SetText(MyGuildNotesVars.tooltip2)
	ItemRefTooltip:Show()
	end

	end)

	MyGNDisplayTable:SetScript("OnLeave", function()
	if MyGNInfoFrameOpen ~= 1 then MyGNInfoFrame:Hide() end
	ItemRefTooltip:Hide()
	end)


    else
	local MyGNDisplayTable = CreateFrame("Button", "MyGNDisplayTable"..Q, MyGuildNotesFrame, "SecureHandlerClickTemplate")
	MyGNDisplayTable:SetID(Q)
	MyGNDisplayTable:SetFrameStrata("MEDIUM")
	MyGNDisplayTable:SetSize(320,20)
	MyGNDisplayTable:SetHitRectInsets(0, 0, 0, 0)
	MyGNDisplayTable:SetPoint("TOPLEFT", 25, -112-(Q*18))
	MyGNDisplayTable:SetHighlightTexture("Interface/QUESTFRAME/UI-QuestTitleHighlight")
	MyGNDisplayTable:EnableMouse(true)
	MyGNDisplayTable:RegisterForClicks("AnyDown")
	MyGNDisplayTable:Show()

	MyGNDisplayTable:SetScript("OnClick", function(self, button, down)
	if button == "LeftButton" and MyGNInfoFrameOpen == 0 then
	if MyGNIndex[Q] ~= 0 then

	MyGNInfoFrameOpen = 1
	MYGNINDEX = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])]
	MyGNPublicNote = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+3]
	MyGNOfficerNote = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+4]
	MyGNPrivateNote = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+16]
	MyGNJoinedDate = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+17]
	MyGNAlias = MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+5]
	MyGNOldAlias = MyGNAliasInput:GetText()
	end
	else
	MyGNInfoFrameOpen = 0
	MyGNInfoFrame:Hide()
	end

	if button == "RightButton" then
	MyGNInfoFrameOpen = 0
	MyGNInfoFrame:Hide()
	end

	end)

	MyGNDisplayTable:SetScript("OnEnter", function()
	if MyGNIndex[Q+MyGNDelta] ~= 0 then
	if MyGNInfoFrameOpen ~= 1 then

	GNInfoTitle:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])])
	GNInfoSummary:SetText("Level "..MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+1].." "..MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+2])
	MyGNPublicNoteInput:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+3])
	MyGNOfficerNoteInput:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+4])
	if MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+17] ~= "" then MyGNJoinedDateInput:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+17]) else MyGNJoinedDateInput:SetText("mm/dd/yyyy") end
	MyGNPrivateNoteInput:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+16])
	MyGNAliasInput:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+5])
	MyGNAliasList6:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+6])
	MyGNAliasList7:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+7])
	MyGNAliasList8:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+8])
	MyGNAliasList9:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+9])
	MyGNAliasList10:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+10])
	MyGNAliasList11:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+11])
	MyGNAliasList12:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+12])
	MyGNAliasList13:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+13])
	MyGNAliasList14:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+14])
	MyGNAliasList15:SetText(MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+15])

	if MyPageShown == 1 or MyPageShown == 4 then
	MyGNQuitDate:SetText("")
	MyGNInfoFrame:Show()
	end

	if MyPageShown == 2 or MyPageShown == 3 or MyPageShown == 5 then
	MyGNQuitDate:SetText("Left: "..MyGuildNotesDataBase[tonumber(MyGNIndex[Q+MyGNDelta])+18])
	MyGNInfoFrame:Show()
	end

	end

	ItemRefTooltip:SetOwner(MyGuildNotesFrame, "MyGuildNotesFrame", 0, -475)

	ItemRefTooltip:SetText(MyGuildNotesVars.tooltip2)
	ItemRefTooltip:Show()
	end


	end)

	MyGNDisplayTable:SetScript("OnLeave", function()
	if MyGNInfoFrameOpen ~= 1 then MyGNInfoFrame:Hide() end
	ItemRefTooltip:Hide()
	end)
    end
end

	for i = 1, 15 do
	local MyGNDisplayShownFrame = _G["MyGNDisplayText" .. i]
	local MyGNDisplayShownTable = _G["MyGNDisplayTable" .. i]
	local MyGNDisplayShownFrame = MyGNDisplayShownTable:CreateFontString("MyGNDisplayText"..i, "ARTWORK")
	MyGNDisplayShownFrame:SetFont("Fonts\\ARIALN.ttf", 16, "OUTLINE")
	MyGNDisplayShownFrame:SetPoint("TOPLEFT", 5, -2)
	end
end

function GN:MyGNDisplayText(delta)
local JUNK1
local JUNK2
local JUNK3

if MyGNDelta == nil then MyGNDelta = 0 end
if delta == nil then delta = 0 end
MyGNDelta = MyGNDelta - delta*MyGuildNotesVars.DELTA
if MyGNDelta <= 0 then MyGNDelta = 0 end

if MyGNDelta >= #MyGuildNotesText-15 then MyGNDelta = #MyGuildNotesText-15 end
if MyGNDelta <= -1 then MyGNDelta = 0 end

    for i = 1, 15 do
	if MyGuildNotesText[i+MyGNDelta] == nil then MyGuildNotesText[i+MyGNDelta] = "" end
	MyGNDisplayShownText = _G["MyGNDisplayText" .. i]
	MyGNDisplayShownText:SetText(GREEN..MyGuildNotesText[i+MyGNDelta])

	if MyGNIndex[i+MyGNDelta] ~= 0 then JUNK1, JUNK2, JUNK3 = string.split(" ", MyGuildNotesText[i+MyGNDelta], 3)
	    if UnitIsInMyGuild(JUNK2) ~= 1 then -- This is someone that left that we have information on but is no longer in the guild.
	    GN:SetClassColor(MyGuildNotesDataBase[(MyGNIndex[i+MyGNDelta]+2)])
	    MyGNDisplayShownText:SetText(GREEN..JUNK1.."  "..CLASSCOLOR..JUNK2.." "..GREEN..JUNK3)
	    end

	    if UnitIsInMyGuild(JUNK2) == 1 then
		for j = 1, MyGuildNotesVars.MyNumMembers do
		name, rankName, rankIndex, level, class, zone, note, onote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR = GetGuildRosterInfo(j)
		    if name == JUNK2 then
	 	    class = classFileName
		    GN:SetClassColor(class)
		    MyGNDisplayShownText:SetText(GREEN..JUNK1.."  "..CLASSCOLOR..JUNK2.." "..GREEN..JUNK3)
		    end
		end
	    end
	end
    end
end


function GN:ShowGUI()

local MyGuildNotesFrame = CreateFrame("Frame", "MyGuildNotesFrame", UIParent)
MyGuildNotesFrame:SetFrameStrata("BACKGROUND")
MyGuildNotesFrame:SetPoint("CENTER", 0, 92)
MyGuildNotesFrame:SetWidth(512)
MyGuildNotesFrame:SetHeight(512)
MyGuildNotesFrame:EnableMouseWheel(true)
MyGuildNotesFrame:Hide()
MyGuildNotesFrame:SetHitRectInsets(0, 165, 0, 0)

	MyGuildNotesFrame:SetScript("OnMouseWheel", function(self, delta)
	GN:MyGNDisplayText(delta)
	MyGuildNotesFrame:Hide()
	GN:MyGNDisplayTables()
	MyGuildNotesFrame:Show()
	end)

local GNTexture = MyGuildNotesFrame:CreateTexture("GNTexture", "MEDIUM", MyGuildNotesFrame)
SetPortraitToTexture(GNTexture, "Interface\\ICONS\\INV_Rareguildtabard")
GNTexture:SetPoint("TOPLEFT", 11, -6)
GNTexture:SetWidth(60)
GNTexture:SetHeight(60)

local MyGuildNotesGuildLevel = MyGuildNotesFrame:CreateFontString("MyGuildNotesGuildLevel", "HIGH")
MyGuildNotesGuildLevel:SetFont("Fonts\\MORPHEUS.ttf", 35, "OUTLINE")
MyGuildNotesGuildLevel:SetPoint("TOPLEFT", 24, -17)
MyGuildNotesGuildLevel:SetText(GetGuildLevel())

local GNtexture = MyGuildNotesFrame:CreateTexture(nil, "BORDER", MyGuildNotesFrame)
GNtexture:SetTexture("Interface\\LFGFRAME\\UI-FRAME-THREEBUTTON-BLANK")

GNtexture:SetAllPoints(MyGuildNotesFrame)

local GNCButton = CreateFrame("Button", nil, MyGuildNotesFrame, "UIPanelCloseButton")
GNCButton:SetFrameStrata("MEDIUM")
GNCButton:ClearAllPoints()
GNCButton:SetPoint("CENTER", 87, 232)

local GuildNameTitle = MyGuildNotesFrame:CreateFontString("GuildNameTitle", "ARTWORK")
GuildNameTitle:SetFont("Fonts\\MORPHEUS.ttf", 18, "OUTLINE")
GuildNameTitle:SetPoint("TOP", -61, -15)
GuildNameTitle:SetTextColor(1, 1, 0)
GuildNameTitle:SetText("My Guild Notes")

local MyGuildNotesTitle = MyGuildNotesFrame:CreateFontString("MyGuildNotesTitle", "ARTWORK")
MYGNFS = 58 - 1.32*(string.len(tostring(MyGuildNotesVars.GuildName)))
MyGuildNotesTitle:SetFont("Fonts\\MORPHEUS.ttf", MYGNFS, "OUTLINE")
MYGNFL = -37 - .5*(string.len(tostring(MyGuildNotesVars.GuildName)))
MyGuildNotesTitle:SetPoint("TOP", -61, MYGNFL)
MyGuildNotesTitle:SetTextColor(1, .42, 0)
MyGuildNotesTitle:SetText(MyGuildNotesVars.GuildName)

local MyGNBorn = MyGuildNotesFrame:CreateFontString(MyGNList, "ARTWORK")
MyGNBorn:SetFont("Fonts\\MORPHEUS.ttf", 17, "OUTLINE")
MyGNBorn:SetPoint("TOP", -64, -77)
MyGNBorn:SetText(GREEN.."Established on: "..MyGuildNotesVars.GuildDate)

MyGNTitle = MyGuildNotesFrame:CreateFontString(MyGNList, "ARTWORK")
MyGNTitle:SetFont("Fonts\\MORPHEUS.ttf", 20, "OUTLINE")
MyGNTitle:SetPoint("TOP", -67, -105)
MyGNTitle:SetTextColor(1,1,0)
MyGNTitle:SetText("Joined the Guild")

-- Buttons
local MyGuildNotesPageButton1 = CreateFrame("Button", "MyGuildsNotesPageButton1", MyGuildNotesFrame, "UIPanelButtonTemplate")
MyGuildNotesPageButton1:SetFrameStrata("LOW")
MyGuildNotesPageButton1:SetWidth(64)
MyGuildNotesPageButton1:SetHeight(27)
MyGuildNotesPageButton1:SetPoint("CENTER", -203, -163)
MyGuildNotesPageButton1:SetText("Joined")
MyGuildNotesPageButton1:RegisterForClicks("AnyDown")
MyGuildNotesPageButton1:SetScript("OnClick", function(self, button, down)
	MyGNTitle:SetText("Joined the Guild")
	GuildRoster()
	QueryGuildEventLog()
PlaySound("igMainMenuOptionCheckBoxOn");
	MyGNInfoFrameOpen = 0
	MyGNInfoFrame:Hide()
	MyGNDelta = 0
	MyPageShown = 1
	end)

local MyGuildNotesPageButton2 = CreateFrame("Button", "MyGuildsNotesPageButton2", MyGuildNotesFrame, "UIPanelButtonTemplate")
MyGuildNotesPageButton2:SetFrameStrata("LOW")
MyGuildNotesPageButton2:SetWidth(50)
MyGuildNotesPageButton2:SetHeight(27)
MyGuildNotesPageButton2:SetPoint("CENTER", -148, -163)
MyGuildNotesPageButton2:SetText("Quit")
MyGuildNotesPageButton2:RegisterForClicks("AnyDown")
MyGuildNotesPageButton2:SetScript("OnClick", function(self, button, down)
	MyGNTitle:SetText("Quit the Guild")
	GuildRoster()
	QueryGuildEventLog()
PlaySound("igMainMenuOptionCheckBoxOn");
	MyGNInfoFrameOpen = 0
	MyGNInfoFrame:Hide()
	MyGNDelta = 0
	MyPageShown = 2
	end)

local MyGuildNotesPageButton3 = CreateFrame("Button", "MyGuildsNotesPageButton3", MyGuildNotesFrame, "UIPanelButtonTemplate")
MyGuildNotesPageButton3:SetFrameStrata("LOW")
MyGuildNotesPageButton3:SetWidth(80)
MyGuildNotesPageButton3:SetHeight(27)
MyGuildNotesPageButton3:SetPoint("CENTER", -85, -163)
MyGuildNotesPageButton3:SetText("Removed")
MyGuildNotesPageButton3:RegisterForClicks("AnyDown")
MyGuildNotesPageButton3:SetScript("OnClick", function(self, button, down)
	MyGNTitle:SetText("Kicked from the Guild")
	GuildRoster()
	QueryGuildEventLog()
PlaySound("igMainMenuOptionCheckBoxOn");
	MyGNInfoFrameOpen = 0
	MyGNInfoFrame:Hide()
	MyGNDelta = 0
	MyPageShown = 3
	end)

local MyGuildNotesPageButton4 = CreateFrame("Button", "MyGuildsNotesPageButton4", MyGuildNotesFrame, "UIPanelButtonTemplate")
MyGuildNotesPageButton4:SetFrameStrata("LOW")
MyGuildNotesPageButton4:SetWidth(69)
MyGuildNotesPageButton4:SetHeight(27)
MyGuildNotesPageButton4:SetPoint("CENTER", -12, -163)
MyGuildNotesPageButton4:SetText("Online")
MyGuildNotesPageButton4:RegisterForClicks("AnyDown")
MyGuildNotesPageButton4:SetScript("OnClick", function(self, button, down)
	MyGNTitle:SetText("Online Members")
	GuildRoster()
	QueryGuildEventLog()
PlaySound("igMainMenuOptionCheckBoxOn");
	MyGNInfoFrameOpen = 0
	MyGNInfoFrame:Hide()
	MyGNDelta = 0
	MyPageShown = 4
	end)

local MyGuildNotesPageButton5 = CreateFrame("Button", "MyGuildsNotesPageButton5", MyGuildNotesFrame, "UIPanelButtonTemplate")
MyGuildNotesPageButton5:SetFrameStrata("LOW")
MyGuildNotesPageButton5:SetWidth(72)
MyGuildNotesPageButton5:SetHeight(27)
MyGuildNotesPageButton5:SetPoint("CENTER", 56, -163)
MyGuildNotesPageButton5:SetText("Search")
MyGuildNotesPageButton5:RegisterForClicks("AnyDown")
MyGuildNotesPageButton5:SetScript("OnClick", function(self, button, down)
	MyGNTitle:SetText("Full DataBase List")
	GuildRoster()
	QueryGuildEventLog()
PlaySound("igMainMenuOptionCheckBoxOn");
	MyGNInfoFrameOpen = 0
	MyGNInfoFrame:Hide()
	MyGNDelta = 0
	MyPageShown = 5
	end)


-- Toggle ICON

local MyGuildNotesICON = CreateFrame("Frame", "MyGuildNotesICON", UIParent)
MyGuildNotesICON:SetFrameStrata("BACKGROUND")
MyGuildNotesICON:SetPoint("CENTER", "Minimap", "CENTER", 26, -165)
MyGuildNotesICON:SetMovable(true)
MyGuildNotesICON:SetUserPlaced(true)
MyGuildNotesICON:EnableMouse(true)
MyGuildNotesICON:SetWidth(37)
MyGuildNotesICON:SetHeight(37)
MyGuildNotesICON:SetHitRectInsets(0, 0, 0, 0)
MyGuildNotesICON:Hide()

local MyGuildNotesICONB = CreateFrame("Button", "MyGuildNotesICONB", MyGuildNotesICON, "SecureHandlerClickTemplate")
MyGuildNotesICONB:SetFrameStrata("MEDIUM")
MyGuildNotesICONB:SetSize(37,37)
MyGuildNotesICONB:SetPoint("CENTER", 0, 0)
MyGuildNotesICONB:SetNormalTexture("Interface\\ICONS\\INV_Epicguildtabard")
MyGuildNotesICONB:SetHighlightTexture("Interface/BUTTONS/CheckButtonHilight")
MyGuildNotesICONB:SetMovable(true)
MyGuildNotesICONB:SetUserPlaced(true)
MyGuildNotesICONB:EnableMouse(true)
MyGuildNotesICONB:RegisterForClicks("Any")
MyGuildNotesICONB:Hide()


MyGuildNotesICONDisplay = MyGuildNotesICONB:CreateFontString("MyGuildNotesICONDisplay", "ARTWORK")
MyGuildNotesICONDisplay:SetFont("Fonts\\MORPHEUS.ttf", 24, "OUTLINE")
MyGuildNotesICONDisplay:SetPoint("CENTER", 1, 0)
MyGuildNotesICONDisplay:SetText(MyGuildNotesVars.MyNumMembers)

local MyGNButtonLabel = MyGuildNotesICONB:CreateFontString("MyGNButtonLabel", "ARTWORK")
MyGNButtonLabel:SetFont("Fonts\\ARIALN.ttf", 12)
MyGNButtonLabel:SetPoint("TOP", 0, -40)
MyGNButtonLabel:SetTextColor(1, 1, 1)
MyGNButtonLabel:SetText("MYGN")


MyGuildNotesICONB:SetScript("OnMouseDown", function(self, button, down)
	if button == "LeftButton" then
	GN:CFToggle();
	return;
	end
	
	if button == "RightButton" and not self.isMoving then   
	self:StartMoving();   
	self.isMoving = true;
	end  
	end)

MyGuildNotesICONB:SetScript("OnMouseUp", function(self, button, up)
	if button == "RightButton" and self.isMoving then
	self:StopMovingOrSizing(GN:MyGuildNotesSave());
	self.isMoving = false;
	end
	end)

MyGuildNotesICONB:SetScript("OnEnter", function()
	ItemRefTooltip:SetOwner(MyGuildNotesICONB, "MyGuildNotesICONB")
	ItemRefTooltip:SetText(MyGuildNotesVars.tooltip)
	ItemRefTooltip:Show()
	end)

MyGuildNotesICONB:SetScript("OnLeave", function()
	ItemRefTooltip:Hide()
	end)
end

function GN:CFToggle()
	QueryGuildEventLog()
	if MyGuildNotesFrame == nil then GN:LoadGUI() end
	if MyGuildNotesFrame:IsVisible() then
	MyGuildNotesFrame:Hide()
PlaySound("igCharacterInfoClose")
	else
	GuildRoster()
	QueryGuildEventLog()
		if MyGuildMOTDFrame ~= nil then
		    MyGuildNotesFrame:ClearAllPoints()
		    MyGuildNotesFrame:SetPoint("CENTER", -100, 92)
		    else
    		    MyGuildNotesFrame:ClearAllPoints()
		    MyGuildNotesFrame:SetPoint("CENTER", 0, 92)
		end
	MyGuildLevel = GetGuildLevel()
	if MyGuildLevel <= 9 then SetPortraitToTexture(GNTexture, "Interface\\ICONS\\INV_Shirt_GuildTabard_01") end
	if MyGuildLevel <= 9 then MyGuildLevel = " "..MyGuildLevel end
	if MyGuildLevel == 25 then SetPortraitToTexture(GNTexture, "Interface\\ICONS\\INV_Epicguildtabard") end
	MyGNTitle:SetText("Joined the Guild")
	GN:MyGNDisplayTables()
	if MyGNDelta ~= 0 then MyPageShown = 2 MyGNDelta = 0 GN:MyGuildNotesRefresh() end
	MyPageShown = 1
	MyGuildNotesGuildLevel:SetText(MyGuildLevel)
	if MyGNInfoFrame ~= nil then MyGNInfoFrame:Hide() MyGNInfoFrameOpen = 0 end
	MyGuildNotesFrame:Show()
PlaySound("igCharacterInfoOpen")
	MyGuildNotesAreOpen = 1
	end
end
